# UniswapOracleLibrary

[Git Source](https://github.com/Ion-Protocol/ion-protocol/blob/88cc595825f1dc2eb738fb93e172a3e8ab7a5c43/src/libraries/uniswap/UniswapOracleLibrary.sol)

Provides functions to integrate with V3 pool oracle

### [Functions](broken://pages/dySUCNwGmSCDF6WJ15GW) <a href="#functions" id="functions"></a>

#### [consult](broken://pages/dySUCNwGmSCDF6WJ15GW) <a href="#consult" id="consult"></a>

Calculates time-weighted means of tick and liquidity for a given Uniswap V3 pool

```
function consult(
    address pool,
    uint32 secondsAgo
)
    internal
    view
    returns (int24 arithmeticMeanTick, uint128 harmonicMeanLiquidity);
```

**Parameters**

| Name         | Type      | Description                                                                   |
| ------------ | --------- | ----------------------------------------------------------------------------- |
| `pool`       | `address` | Address of the pool that we want to observe                                   |
| `secondsAgo` | `uint32`  | Number of seconds in the past from which to calculate the time-weighted means |

**Returns**

| Name                    | Type      | Description                                                                        |
| ----------------------- | --------- | ---------------------------------------------------------------------------------- |
| `arithmeticMeanTick`    | `int24`   | The arithmetic mean tick from (block.timestamp - secondsAgo) to block.timestamp    |
| `harmonicMeanLiquidity` | `uint128` | The harmonic mean liquidity from (block.timestamp - secondsAgo) to block.timestamp |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionprotocol.io/devs/smart-contract-architecture/libraries/uniswap/uniswaporaclelibrary.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
